package de.intevation.flys.exports;

import org.jfree.chart.axis.ValueAxis;

import org.jfree.data.Range;

/** Two Ranges that span a rectangular area. */
public class ChartArea {
    protected Range xRange;
    protected Range yRange;

    public ChartArea(Range rangeX, Range rangeY) {
        this.xRange = rangeX;
        this.yRange = rangeY;
    }

    public ChartArea(ValueAxis axisX, ValueAxis axisY) {
        this.xRange = axisX.getRange();
        this.yRange = axisY.getRange();
    }

    public double ofLeft(double percent) {
        return xRange.getLowerBound()
            + xRange.getLength() * percent;
    }

    public double ofRight(double percent) {
        return xRange.getUpperBound()
            - xRange.getLength() * percent;
    }

    public double ofGround(double percent) {
        return yRange.getLowerBound()
            + yRange.getLength() * percent;
    }

    public double atTop() {
        return yRange.getUpperBound();
    }

    public double atGround() {
        return yRange.getLowerBound();
    }

    public double atRight() {
        return xRange.getUpperBound();
    }

    public double atLeft() {
        return xRange.getLowerBound();
    }

    public double above(double percent, double base) {
        return base + yRange.getLength() * percent;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
